'''
Copyright ? 2014 ESRI
You may freely redistribute and use this sample code, with or without modification, provided you include the original copyright notice and use restrictions.

Disclaimer:

THE SAMPLE CODE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL ESRI OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 SUSTAINED BY YOU OR A THIRD PARTY, HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT ARISING
 IN ANY WAY OUT OF THE USE OF THIS SAMPLE CODE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

For additional information, contact:
Environmental Systems Research Institute, Inc.
Attn: Contracts and Legal Services Department
380 New York Street Redlands, California, 92373
USA
'''

import sys, os, subprocess, arcpy, time, socket
# tempfile, shutil, time, urllib, json

####################################
#modify this section
####################################
#where is the source
MyRasterSource=r"C:\Data\MODIS_EVI\MOD13C2_2009"
#what is the raster type
MyRasterType=r"C:\Data\MODIS_EVI\MOD13_EVI_var1.art.xml"
#What is my workspace
MyWorkspace = r"C:\Data\MODIS_EVI\mysde.sde"
MdName = "MODIS_EVI"
arcpy.gp.logHistory = False
####################################

#do not modify this section
Mdpath = MyWorkspace+"\\"+MdName


def RemoveOldData():
    try:
        arcpy.RemoveRastersFromMosaicDataset_management(Mdpath, "ObjectID>0", "NO_BOUNDARY","MARK_OVERVIEW_ITEMS",  "NO_DELETE_OVERVIEW_IMAGES", "NO_DELETE_ITEM_CACHE", "REMOVE_MOSAICDATASET_ITEMS", "NO_CELL_SIZES")
        print arcpy.GetMessages()+ "\n\n"
    except:
        print arcpy.GetMessages()+ "\n\n"
def AddNewData():

    #Process: Add Rasters To Mosaic Dataset
    TCP_IP = '127.0.0.1'
    TCP_PORT = 5565
    MESSAGE = "newImage,true\n"
    print(MESSAGE)
    sok = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    sok.connect((TCP_IP, TCP_PORT))
    for root, dirs, files in os.walk(MyRasterSource):
        for dir in dirs:
            try:
                    print "Add rasters"
                    arcpy.AddRastersToMosaicDataset_management(Mdpath, MyRasterType, MyRasterSource+"\\"+dir, "NO_CELL_SIZES", "NO_BOUNDARY", "NO_OVERVIEWS", "", "0", "1500", "", "*.*", "SUBFOLDERS", "ALLOW_DUPLICATES", "NO_PYRAMIDS", "NO_STATISTICS", "NO_THUMBNAILS", "", "NO_FORCE_SPATIAL_REFERENCE")
                    print "Calculate cell size"
                    arcpy.CalculateCellSizeRanges_management(Mdpath, "MinPS is Null or MaxPS is Null", "MIN_CELL_SIZES", "MAX_CELL_SIZES", 100, 0.1, "UPDATE_MISSING_ONLY")
                    print arcpy.GetMessages()+ "\n\n"
                    sok.send(MESSAGE)
            except:
                    print arcpy.GetMessages()+ "\n\n"

            try:
                    print "Rebuild Indexes"
                    arcpy.RebuildIndexes_management(MyWorkspace, "NO_SYSTEM",MdName, "ALL")
                    print arcpy.GetMessages()+ "\n\n"
            except:
                    print arcpy.GetMessages()+ "\n\n"

            time.sleep(3)

    #sok.close()

def main():
    try:
        #clean up, and cycle through, to simulate real time data push to mosaic dataset
        #you need to have tcp port 5565 configured from geoevent processor
        rounds = 1;
        while(rounds<300):
            RemoveOldData()
            AddNewData()
            rounds = rounds+1
    except:
        arcpy.AddError("Failed")
        print arcpy.GetMessages()+ "\n\n"
        print "something wrong"

if __name__ == "__main__":
    main()








